Merge branch 'jk/reflog-date' into next
[git] / git-sh-setup.sh
1 #!/bin/sh
2 #
3 # This is included in commands that either have to be run from the toplevel
4 # of the repository, or with GIT_DIR environment variable properly.
5 # If the GIT_DIR does not look like the right correct git-repository,
6 # it dies.
7
8 # Having this variable in your environment would break scripts because
9 # you would cause "cd" to be taken to unexpected places.  If you
10 # like CDPATH, define it for your interactive shell sessions without
11 # exporting it.
12 unset CDPATH
13
14 git_broken_path_fix () {
15         case ":$PATH:" in
16         *:$1:*) : ok ;;
17         *)
18                 PATH=$(
19                         SANE_TOOL_PATH="$1"
20                         IFS=: path= sep=
21                         set x $PATH
22                         shift
23                         for elem
24                         do
25                                 case "$SANE_TOOL_PATH:$elem" in
26                                 (?*:/bin | ?*:/usr/bin)
27                                         path="$path$sep$SANE_TOOL_PATH"
28                                         sep=:
29                                         SANE_TOOL_PATH=
30                                 esac
31                                 path="$path$sep$elem"
32                                 sep=:
33                         done
34                         echo "$path"
35                 )
36                 ;;
37         esac
38 }
39
40 # @@BROKEN_PATH_FIX@@
41
42 die() {
43         echo >&2 "$@"
44         exit 1
45 }
46
47 GIT_QUIET=
48
49 say () {
50         if test -z "$GIT_QUIET"
51         then
52                 printf '%s\n' "$*"
53         fi
54 }
55
56 if test -n "$OPTIONS_SPEC"; then
57         usage() {
58                 "$0" -h
59                 exit 1
60         }
61
62         parseopt_extra=
63         [ -n "$OPTIONS_KEEPDASHDASH" ] &&
64                 parseopt_extra="--keep-dashdash"
65
66         eval "$(
67                 echo "$OPTIONS_SPEC" |
68                         git rev-parse --parseopt $parseopt_extra -- "$@" ||
69                 echo exit $?
70         )"
71 else
72         dashless=$(basename "$0" | sed -e 's/-/ /')
73         usage() {
74                 die "Usage: $dashless $USAGE"
75         }
76
77         if [ -z "$LONG_USAGE" ]
78         then
79                 LONG_USAGE="Usage: $dashless $USAGE"
80         else
81                 LONG_USAGE="Usage: $dashless $USAGE
82
83 $LONG_USAGE"
84         fi
85
86         case "$1" in
87                 -h|--h|--he|--hel|--help)
88                 echo "$LONG_USAGE"
89                 exit
90         esac
91 fi
92
93 set_reflog_action() {
94         if [ -z "${GIT_REFLOG_ACTION:+set}" ]
95         then
96                 GIT_REFLOG_ACTION="$*"
97                 export GIT_REFLOG_ACTION
98         fi
99 }
100
101 git_editor() {
102         : "${GIT_EDITOR:=$(git config core.editor)}"
103         : "${GIT_EDITOR:=${VISUAL:-${EDITOR}}}"
104         case "$GIT_EDITOR,$TERM" in
105         ,dumb)
106                 echo >&2 "No editor specified in GIT_EDITOR, core.editor, VISUAL,"
107                 echo >&2 "or EDITOR. Tried to fall back to vi but terminal is dumb."
108                 echo >&2 "Please set one of these variables to an appropriate"
109                 echo >&2 "editor or run $0 with options that will not cause an"
110                 echo >&2 "editor to be invoked (e.g., -m or -F for git-commit)."
111                 exit 1
112                 ;;
113         esac
114         eval "${GIT_EDITOR:=vi}" '"$@"'
115 }
116
117 is_bare_repository () {
118         git rev-parse --is-bare-repository
119 }
120
121 cd_to_toplevel () {
122         cdup=$(git rev-parse --show-cdup)
123         if test ! -z "$cdup"
124         then
125                 # The "-P" option says to follow "physical" directory
126                 # structure instead of following symbolic links.  When cdup is
127                 # "../", this means following the ".." entry in the current
128                 # directory instead textually removing a symlink path element
129                 # from the PWD shell variable.  The "-P" behavior is more
130                 # consistent with the C-style chdir used by most of Git.
131                 cd -P "$cdup" || {
132                         echo >&2 "Cannot chdir to $cdup, the toplevel of the working tree"
133                         exit 1
134                 }
135         fi
136 }
137
138 require_work_tree () {
139         test $(git rev-parse --is-inside-work-tree) = true ||
140         die "fatal: $0 cannot be used without a working tree."
141 }
142
143 get_author_ident_from_commit () {
144         pick_author_script='
145         /^author /{
146                 s/'\''/'\''\\'\'\''/g
147                 h
148                 s/^author \([^<]*\) <[^>]*> .*$/\1/
149                 s/'\''/'\''\'\'\''/g
150                 s/.*/GIT_AUTHOR_NAME='\''&'\''/p
151
152                 g
153                 s/^author [^<]* <\([^>]*\)> .*$/\1/
154                 s/'\''/'\''\'\'\''/g
155                 s/.*/GIT_AUTHOR_EMAIL='\''&'\''/p
156
157                 g
158                 s/^author [^<]* <[^>]*> \(.*\)$/\1/
159                 s/'\''/'\''\'\'\''/g
160                 s/.*/GIT_AUTHOR_DATE='\''&'\''/p
161
162                 q
163         }
164         '
165         encoding=$(git config i18n.commitencoding || echo UTF-8)
166         git show -s --pretty=raw --encoding="$encoding" "$1" -- |
167         LANG=C LC_ALL=C sed -ne "$pick_author_script"
168 }
169
170 # Make sure we are in a valid repository of a vintage we understand,
171 # if we require to be in a git repository.
172 if test -z "$NONGIT_OK"
173 then
174         GIT_DIR=$(git rev-parse --git-dir) || exit
175         if [ -z "$SUBDIRECTORY_OK" ]
176         then
177                 test -z "$(git rev-parse --show-cdup)" || {
178                         exit=$?
179                         echo >&2 "You need to run this command from the toplevel of the working tree."
180                         exit $exit
181                 }
182         fi
183         test -n "$GIT_DIR" && GIT_DIR=$(cd "$GIT_DIR" && pwd) || {
184                 echo >&2 "Unable to determine absolute path of git directory"
185                 exit 1
186         }
187         : ${GIT_OBJECT_DIRECTORY="$GIT_DIR/objects"}
188 fi
189
190 # Fix some commands on Windows
191 case $(uname -s) in
192 *MINGW*)
193         # Windows has its own (incompatible) sort and find
194         sort () {
195                 /usr/bin/sort "$@"
196         }
197         find () {
198                 /usr/bin/find "$@"
199         }
200         ;;
201 esac